# PortSwigger

[PortSwigger](https://portswigger.net/burp/) is a tool for exploring the security in the network and such as traffic and decode data. The community version only provide the execution of manually tasks. The Enterprise version brings other functionality such as scheduler and CI.

**Installation**

Download jar from [here](https://portswigger.net/burp/releases/professional-community-2020-9?requestededition=community)

Check java version > 8

```bash
java -version
```

Execute: 

```bash
java -jar burpsuite_community_v2020.9.jar
```

[Configure Proxy](https://portswigger.net/burp/documentation/desktop/penetration-testing/configuring-your-browser) 

Firefox -  Network Settings → "Manual proxy configuration" radio button.  
HTTP proxy  127.0.0.1 port 8080
Make sure the "Use this proxy server for all protocols" box is checked. Delete anything that appears in the "No proxy for" field. Then click "OK" to close all of the options dialogs.

**Test with DVWA**

[Tutorial](https://www.youtube.com/watch?v=jzlv0n13ln0)

[Add certificate](https://portswigger.net/support/installing-burp-suites-ca-certificate-in-firefox#:~:text=Click) 

Problems in configuration:

- [https://forum.portswigger.net/thread/burp-suite-not-intercepting-dvwa-traffic-58265b8d](https://forum.portswigger.net/thread/burp-suite-not-intercepting-dvwa-traffic-58265b8d)
- [https://security.stackexchange.com/questions/187069/burpsuite-just-passthrough-firefox-detect-portal](https://security.stackexchange.com/questions/187069/burpsuite-just-passthrough-firefox-detect-portal)
- [https://forum.portswigger.net/thread/unable-to-use-burp-with-latest-version-of-firefox-0bdbbf0d](https://forum.portswigger.net/thread/unable-to-use-burp-with-latest-version-of-firefox-0bdbbf0d)

[Solution](https://security.stackexchange.com/questions/142552/how-to-configure-burp-suite-for-localhost-application): 
1- Remove certificate from browser and add it again 

2- in Firefox browser type `about:config` in the URL and

- set `network.security.ports.banned.override` to 8080
- set `network.proxy.allow.hijacking_localhost` to `true`

If it is working when enable 'Intercept on' in burp and do a request at DVWA you will see:

![Screen_Shot_2020-09-09_at_9.11.24_AM.png](Screen_Shot_2020-09-09_at_9.11.24_AM.png)

The Enterprise version provides the possibility to automate CSRF, but with the community version we can only do manually testing.
