# Attack Generation

**Objective:** Have available a platform that acts as a laboratory to generate attacks and data for common behavior for a website.  

[List of tools that might be useful](Tools.md)  

**Data**

[Classes to support](https://gitlab.fing.edu.uy/gsi/web-application-attacks-datasets/-/tree/master/ecml_pkdd)  XSS, SqlInjection, LdapInjection, XPathInjection, PathTransversal, OsCommanding, SSI

# Experiments

[Damn Vulnerable Web Application - DVWA](https://gitlab.com/ai-research-ort/dvwa-vulnerable-site/-/blob/master/README.md)

[Web Application Firewall (WAF)](Attack_Generation/Web%20Application%20Firewall%20(WAF).md)

[SQL Injections](https://gitlab.com/ai-research-ort/sqlmap-attacks/-/blob/master/sqlinjections/SQLInjections.md)

[ZaProxy](zaproxy/ZaProxy.md)

[PortSwigger](PortSwigger/PortSwigger.md)

[Automatic attacks to DVWA](https://gitlab.com/ai-research-ort/dvwa-automation)
# Architecture

The platform needs to provide two use cases:

- Attack generation → WAF → site
- Common behavior generation → WAF → site

The generated log files will be input for a machine learning model that classifies among attack and not attack. 
To generate the HTTP request we can use Postman or not. Something that executes the same requests as Postman, since I don't know if the Postman test can run 'forever' . We would need to try, but if not we can just have different microservices to generate this requests.

![Architecture](Architecture.png)
