# ZaProxy


[ZaProxy](https://www.zaproxy.org/) is a proxy web app scanner

It is used for penesteting testing to help to identify vulnerabilities 

The proxy is located between the browser from the tester and the application to be tested, intercepts messages, modifies the content and sends packages to the destiny. 

**Execution:** it can be execute as stand-alone or daemon

**Automatization:** automate crawling to a web site. As a result, it reconstructs a map of the invoked application and returns an alert in case that there has been a problem for each pair request-response. Supports different languages  (Java, Python, Node.js PHP, Ruby) and it can run as endless mode

**Install:** [docker](https://www.zaproxy.org/docs/docker/about/)

## ZAP - Webswing: ZAP Desktop UI
[zap-webswing.sh](http://zap-webswing.sh/)

```bash
docker run -u zap -p 8080:8080 -p 8090:8090 -i owasp/zap2docker-stable zap-webswing.sh
```

From the [ZAP Desktop U](http://localhost:8080/zap/)I you can send automate attacks to [DVWA](http://localhost) . You need to insert the url to attack. Since we are running DVWA in a docker container, you will need to provide the ip address for the container.  Execute the following command to get the ip: 

```bash
docker inspect -f docker_id 
```

```json
{...
"NetworkID": "0f3283700157727f1ac14c2d6ba93d4e5185c2a1afec5b56936a80e47de3812e",
"EndpointID": "680756a76348dea468bc0319af4840b0de66b408c7dd80a5731a839f8b05c49d",
**"Gateway": "172.17.0.1",**
"IPAddress": "172.17.0.2",
"IPPrefixLen": 16,
"IPv6Gateway": "",
"GlobalIPv6Address": "",
"GlobalIPv6PrefixLen": 0,
"MacAddress": "02:42:ac:11:00:02",
"DriverOpts": null
}
```

![Attack](images/attack.png)

There are some of the logs generated at */var/log/apache2/*     
 
```bash
172.17.0.1 - - [13/Sep/2020:00:13:04 +0000] "GET /dvwa/includes/DBMS/PGSQL.php HTTP/1.1" 500 185 "http://172.17.0.1/dvwa/includes/DBMS/" "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:71.0) Gecko/20100101 Firefox/71.0"
172.17.0.1 - - [13/Sep/2020:00:13:04 +0000] "GET /dvwa/includes/DBMS/?C=S;O=D HTTP/1.1" 200 1347 "http://172.17.0.1/dvwa/includes/DBMS/?C=S;O=A" "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:71.0) Gecko/20100101 Firefox/71.0"
172.17.0.1 - - [13/Sep/2020:00:13:04 +0000] "GET /dvwa/includes/dvwaPage.inc.php HTTP/1.1" 200 193 "-" "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:71.0) Gecko/20100101 Firefox/71.0"
172.17.0.1 - - [13/Sep/2020:00:13:04 +0000] "GET /dvwa/includes/dvwaPhpIds.inc.php HTTP/1.1" 200 147 "-" "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:71.0) Gecko/20100101 Firefox/71.0"
172.17.0.1 - - [13/Sep/2020:00:13:04 +0000] "GET /dvwa/includes/?C=D;O=D HTTP/1.1" 200 1550
"http://172.17.0.1/dvwa/includes/?C=D;O=A" "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:71.0)
Gecko/20100101 Firefox/71.0"
==> /var/log/apache2/error.log <==
[Sun Sep 13 00:13:04.217176 2020] [:error] [pid 303] [client 172.17.0.1:54676] PHP Fatal error: Uncaught Error: Call to undefined function dvwaMessagePush() in /var/www/html/dvwa/includes/DBMS/MySQL.php:12\nStack trace:\n#0 {main}\n thrown in /var/www/html/dvwa/includes/DBMS/MySQL.php on line 12, referer: http://172.17.0.1/dvwa/includes/DBMS/
[Sun Sep 13 00:13:04.422482 2020] [:error] [pid 311] [client 172.17.0.1:54864] PHP Fatal error: Uncaught Error: Call to undefined function dvwaMessagePush() in /var/www/html/dvwa/includes/DBMS/PGSQL.php:11\nStack trace:\n#0 {main}\n thrown in /var/www/html/dvwa/includes/DBMS/PGSQL.php on line 11, referer: http://172.17.0.1/dvwa/includes/DBMS/
[Sun Sep 13 00:13:04.824677 2020] [:error] [pid 301] [client 172.17.0.1:54614] PHP Warning: define() expects at least 2 parameters, 1 given in /var/www/html/dvwa/includes/dvwaPhpIds.inc.php on line 4
==> /var/log/apache2/access.log <==
172.17.0.1 - - [13/Sep/2020:00:13:05 +0000] "GET /dvwa/js HTTP/1.1" 301 517 "http://172.17.0.1/dvwa/js/" "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:71.0) Gecko/20100101 Firefox/71.0"
172.17.0.1 - - [13/Sep/2020:00:13:05 +0000] "GET /dvwa/js/ HTTP/1.1" 200 1346 "-" "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:71.0) Gecko/20100101 Firefox/71.0"
1
```

At the Alerts tab you can find all the vulnerabilities found.     

## ZAP CLI    
[ZAP CLI](https://github.com/Grunny/zap-cli) is a ZAP wrapper written in Python. It provides a simple way to do scanning from the command line.     
Get the local IP to set the url to be attacked:    
  
```bash
DOCKER_IP=$(ipconfig getifaddr en0)
```
   
Using quick-scan command:   

```bash
docker run -i owasp/zap2docker-stable zap-cli quick-scan --self-contained --start-options '-config api.disablekey=true' http://$DOCKER_IP:80
```   

Use only xss scanner:   
  
```bash
docker run -i owasp/zap2docker-stable zap-cli quick-scan -sc -o '-config api.disablekey=true' -s xss http://$DOCKER_IP:80
```    

## Test Report    
Following [this](https://softwaretester.info/setup-learning-environment-for-security-testing/) tutorial     
Change the following step: start ZAP in Browser for:        

```bash
# start ZAP in Browser
$ open -a Safari http://localhost:8080/zap
```     

At the end this file is generated:    
[test.xml](images/test.xml)   
Which can be imported at Threadfix to visualize the report:     

![Threadfix](images/threadfix.png)  
**Download as html:** The report also can  be exported as .html: [test-2.html](images/test-2.html)  
**From the ZAP-cli:** The report also can be generated by the zap-cli:    
 
```bash
docker run -v $(pwd):/zap/wrk/:rw -t owasp/zap2docker-weekly [zap-baseline.py](http://zap-baseline.py/) -t [http://$](http://192.168.0.104/)DOCKER_IP[:80](http://192.168.0.104/) -g gen.conf -r testreport.html
```   

[testreport.html](images/testreport.html)    
Check manually the invoke   
At the ZAP UI go to:   
![zapui](images/zapui.png)
The result should be like: 
![response](images/response.png)

[Authenticated Scan using OWASP-ZAP](https://medium.com/@secureica/authenticated-scan-using-owasp-zap-f0a71dafe41)

# Conclusions

- Automated test can be made with ZAP cli
- With ZAP UI you can intercept all request made to the vulnerable website and create attacks from them
- ZAP provides basic vulnerabilities test
- ZAP is open source, so the code can be modified to add features for our case
- The test results can be exported and visualized, so we can check the amount of attacks
