# List of tools that might be useful

Investigate different tools that might help us to develop this platform

# Vulnerable sites

## BWA

Broken Web Application - a collection of intentionally vulnerable web applications distributed by OWASP in a Virtual Machine.

## Juice SHOP

[https://github.com/bkimminich/juice-shop](https://github.com/bkimminich/juice-shop)

Vulnerable site web application 

It might be useful to generate different data from DVWA 

## Damn Vulnerable Web Application - DVWA

[http://www.dvwa.co.uk/](http://www.dvwa.co.uk/) 

**Characteristics:**

- Simulation of a vulnerable website
- Compatible with XAMPP [https://www.apachefriends.org/index.html](https://www.apachefriends.org/index.html) (open source package form Apache which contains MariaDB, PHP, y Perl)
- Run in Docker
- **Vulnerabilities** - the site is vulnerable to the following attacks:
    - [Brute Force:](https://community.broadcom.com/symantecenterprise/communities/community-home/librarydocuments/viewdocument?DocumentKey=656f46ef-9e3c-4c1e-a629-594d76fb5339&CommunityKey=1ecf5f55-9545-44d6-b0f4-4e4a7f5f5e68&tab=librarydocuments) generate possible combinations for passwords until finding the right password
    - [Cross Site Request Forgery (CSRF):](https://owasp.org/www-community/attacks/csrf) falsification of the request in cross-site from the user's cookies.
    - [Command Injection:](https://owasp.org/www-community/attacks/Command_Injection) injects arbitraty commands in the host's operation system.
    - [File Inclusion:](https://en.wikipedia.org/wiki/File_inclusion_vulnerability) These type of vulnerabilities occur when a web application allows the user to submit input into files or upload files to the server.
    - [File Upload](https://owasp.org/www-community/vulnerabilities/Unrestricted_File_Upload): when the site allows the user to upload a file and then execute it.
    - [XSS:](https://owasp.org/www-community/attacks/xss/) script injections
    - [SQL Injection:](https://owasp.org/www-community/attacks/SQL_Injection) send SQL queries that manipulates the database

Problem: The simulations are manually. Here are provided several tools that might be useful to automate the generation of each type of attack. 

[Automate tools](List%20of%20tools%20that%20might%20be%20useful%2095a473615888457c8bc6920874c91aa6/Automate%20tools%20c909605f19194d5fb346b41919390ca8.csv)

## Web Application Firewall (WAF)

Firewall for monitoring, filtering and block HTTP traffic from and to a specific web application. While inspecting HTTP traffic, it let you to control and protect your site from attacks. 

[ModSecurity](https://github.com/SpiderLabs/ModSecurity/wiki) - ModSecurity is an open source, cross platform web application firewall (WAF). It has a robust event-based programming language which provides protection from a range of attacks against web applications and allows for HTTP traffic monitoring, logging and real-time analysis.

**Install ModSecurity in apache:**

```bash
apt-get -y update
apt-get install -y libapache2-mod-security2
service apache2 restart
```

**Enable/Disable ModSecurity**

Edit the config file /etc/modsecurity/modsecurity.conf the parameter SecRuleEngine: 

- SecRuleEngine Off: it means that modsecurity is not enabled
- SecRuleEngine DetectionOnly: it means that modsecurity is enabled only for detection, so the requests are not stopped
- SecRuleEngine On: it means that if some of the configured rules fails, the request is not allowed to pass.

**Configure rules**

[Basic configuration:](https://www.modsecurity.org/CRS/Documentation/install.html) basic configuration with OWASP ModSecurity rules. 

After installing modsecurity, execute: 

## SQLMAP

[Sqlmap](http://sqlmap.org/) is an open source penetration testing tool that automates the process of detecting and exploiting SQL injection for different database management systems.

Execution: bash commands 

Code: the code is available in the following  [link](https://github.com/sqlmapproject/sqlmap) 

Install:  inside a docker container execute:

```bash
apt-get -y update
apt-get install -y sqlmap
```

## **Postman**

To send HTTP requests 

Execution: Provides app to send automate HTTP request to an url. You can single requests, create workspaces, automate testing and save requests. 

install: [https://www.postman.com/](https://www.postman.com/)

Docker:  [https://hub.docker.com/r/postman/newman/](https://hub.docker.com/r/postman/newman/)

## PortSwigger

[PortSwigger](https://portswigger.net/burp/) is a tool for exploring the security in the network and such as traffic and decode data. The community version only provide the execution of manually tasks. The Enterprise version brings other functionality such as scheduler and CI. 

# ZaProxy

[https://www.zaproxy.org/](https://www.zaproxy.org/) proxy web app scanner

Objective: Penesteting testing - help to identify vulnerabilities 

Proxy: It is located between the browser from the tester and the application to be tested, intercepts messages, modifies the content and sends packages to the destiny. 

## OpenSource Projects

[Juice SHOP](https://www.notion.so/Juice-SHOP-4573aff1cdd04cd6a338f8bee36d440d)

[investigate postman - docker](https://www.notion.so/investigate-postman-docker-3e3b936874a5405fa7ba737b0916dec7)

[automate test in postman](https://www.notion.so/automate-test-in-postman-d6344a35fea74eac90009ea5422c2eda)

[threadfix](https://www.notion.so/threadfix-0093954e6c9f452697e880485223e197)

[jmeter](https://www.notion.so/jmeter-3430006bdc0749acab937ed86ce89cbb)

[Acunetix Web Vulnerability Scanner (WVS)](https://www.notion.so/Acunetix-Web-Vulnerability-Scanner-WVS-68dbb64854b74a34be28b37dbb4a5ae4)

[Web Application Attack and Audit Framework (W3AF)](https://www.notion.so/Web-Application-Attack-and-Audit-Framework-W3AF-23361e3ca2ee4dd58980aaa72470ff3a)

[tulpar](https://github.com/tulpar/tulpar)

[shodan](https://www.notion.so/shodan-8b2cec483ee847cd876c5b8ebcb15355)

[Openvas](https://www.notion.so/Openvas-a11fbca398304e629f6cf629e54c99d3)

[dorkbot](https://www.notion.so/dorkbot-99c278672fb9420ebb3ec39714c3e758)

[Nessus](https://www.notion.so/Nessus-d6db26ab9d3a466eb86876496311de88)

[Change IP in the attacks](https://www.notion.so/Change-IP-in-the-attacks-9c115914f28649ac881338744717d824)

[nessi2](https://www.notion.so/nessi2-d32ca932fe824719a1b14cd65cb905d1)

[infectionmonkey](https://www.guardicore.com/infectionmonkey/)

[c](https://github.com/mitre/caldera)aldera

[atomic-red-team](https://github.com/redcanaryco/atomic-red-team)

# Useful blogs or articles

Blogs that might be useful

- DVWA articles - [https://medium.com/@dannybeton](https://medium.com/@dannybeton)
- List of security tools: [https://awesomehacking.org/](https://awesomehacking.org/)
- Paper - apply ML to classify attacks [https://www.sciencedirect.com/science/article/pii/S2210832717300169](https://www.sciencedirect.com/science/article/pii/S2210832717300169)
- Dockerfiles - [https://github.com/khast3x/Offensive-Dockerfiles](https://github.com/khast3x/Offensive-Dockerfiles)